#pragma once
#include <us/gov/types.h>
#include <us/gov/io/seriable_map.h>

namespace us::gov::cash {

    struct m_t: io::seriable_map<string, string> {
        m_t();
        m_t(const m_t&);
        m_t& operator = (const m_t&) = delete;
        void dump(const string& prefix, ostream&) const;
        void hash_data_to_sign(sigmsg_hasher_t&) const;
        void hash_data(crypto::ripemd160&) const;
        void merge(const m_t&);

    };

}

