#pragma once
#include <string>
#include <iostream>

namespace us::gov::engine {

    using namespace std;

    struct addr_t {
        virtual ~addr_t() {}
        virtual void to_stream(ostream& os) const = 0;
        static addr_t* from_stream(istream&);
    };

    ostream& operator << (ostream&, const addr_t&);

}

