#pragma once
#include <string>
#include <array>

namespace us::gov::engine {

    using namespace std;

    struct param_t {
        enum consensus_t { majority = 0, average, median, num_types };
        constexpr static array<const char*, num_types> typestr = {"majority", "average", "median"};

        param_t(int id, consensus_t type): id(id), consensus_type(type) {}
        inline bool operator <(const param_t& other) const { return id < other.id; }

        int id;
        consensus_t consensus_type;
    };

}

