#pragma once

#include <us/gov/socket/client.h>

#include "net.h"
#include "rpc_peer_t.h"
#include "svcfish_t.h"

namespace us::gov::engine {

    struct rpc_daemon_t: net::rpc_daemon_t {
        using b = net::rpc_daemon_t;

        rpc_daemon_t(channel_t channel, dispatcher_t*);
        ~rpc_daemon_t() override;

        //socket::client* create_client() override;

        const rpc_peer_t& get_peer() const { return static_cast<const rpc_peer_t&>(*peer); }
        rpc_peer_t& get_peer() { return static_cast<rpc_peer_t&>(*peer); }

    public:
        void dump(const string& prefix, ostream&) const;
        void dump_all(const string& prefix, ostream&) const override;

    };

}

