#pragma once
#include <vector>
#include <inttypes.h>
#include <type_traits>
#ifdef DEBUG
   struct assert_is_root_namespace;
   static_assert(std::is_same<assert_is_root_namespace, ::assert_is_root_namespace>::value, "Not root namespace. Check includes.");
#endif

#include <us/gov/socket/types.h>
#include <us/gov/socket/datagram.h>
#include <us/gov/id/types.h>
#include <us/gov/ko.h>

namespace us {

    using namespace std;
    using blob_t = vector<uint8_t>;
    using datagram = us::gov::socket::datagram;

}

namespace us::gov::io {

    using namespace us;

}

