#pragma once
#include <us/gov/peer/rpc_peer_t.h>
#include "api.h"
#include "types.h"

namespace us::gov::relay {

    struct rpc_peer_t: base_ns::rpc_peer_t, caller_api  {
        using b = base_ns::rpc_peer_t;
        using b::rpc_peer_t;

        bool process_work(datagram*) override;

        #ifdef has_us_gov_relay_api
            #include <us/api/generated/gov/c++/relay/cllr_override>
        #endif
    };

}

