#pragma once
#include "send_queue.h"
#include "rendezvous_t.h"
#include <chrono>

namespace us::gov::socket {

    struct datagram;
    struct client;

    struct caller_daemon_t: send_queue_t {
        using b = send_queue_t;

        caller_daemon_t();
        ko start();
        void stop();
        ko send1(client&, datagram*);
        void dump(const string& prefix, ostream&) const;

    public:
        rendezvous_t rendezvous;
        bool encrypt_traffic{true};
        api_v_t api_v{0};

    };

}

