#pragma once
#include <us/wallet/engine/rpc_peer_t.h>

namespace us::wallet::cli {

    struct rpc_peer_t: engine::rpc_peer_t {
        using b = engine::rpc_peer_t;

        using b::rpc_peer_t;

        void dump(const string& prefix, ostream&) const;
        void dump_all(const string& prefix, ostream&) const override;

        inline ko authorize(const pub_t&, pin_t, request_data_t&) override { return ok; }
        void on_peer_disconnected(const reason_t&) override;
        void on_I_disconnected(const reason_t&) override;
        ko verification_completed(pport_t, pin_t, request_data_t&) override;
        void verification_result(request_data_t&&) override;

    };

}

