#pragma once

#include <map>

#include <us/gov/socket/types.h>

namespace us::wallet::engine {

    struct svcfish_t final {
        using db_t = map<svc_t, svc_t>;

        svc_t from_prev(svc_t svc) const;
        svc_t to_prev(svc_t svc) const;


        db_t db01 {
            #include <us/api/generated/gov/c++/svc_from_prev_v>
            #include <us/api/generated/wallet/c++/svc_from_prev_v>
        };

        db_t db10 {
            #include <us/api/generated/gov/c++/svc_to_prev_v>
            #include <us/api/generated/wallet/c++/svc_to_prev_v>
        };

    };

}

