#pragma once
#include "doc_t.h"
#include "expiry_doc_t.h"
#include "signed_doc_t.h"

namespace us::wallet::trader::cert {

    using magic_t = doc0_t::magic_t;

    struct cert_traits {
        static constexpr magic_t magic{10};
        static constexpr auto name{"cert"};
        static constexpr auto long_name{"Certificate"};
        static constexpr auto long_name_es{"Certificado"};
    };

    using cert_t = doc_t<signed_expiry_doc_t, cert_traits>;

}

