package plebble.trader;
import android.app.Application;                                                                // Application
import java.util.ArrayList;                                                                    // ArrayList
import java.util.Arrays;                                                                       // Arrays
import android.media.AudioManager;                                                             // AudioManager
import java.net.Authenticator;                                                                 // Authenticator
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import static us.gov.io.types.blob_t;                                                          // blob_t
import java.io.BufferedInputStream;                                                            // BufferedInputStream
import java.io.BufferedReader;                                                                 // BufferedReader
import us.gov.socket.busyled_t;                                                                // busyled_t
import java.io.ByteArrayOutputStream;                                                          // ByteArrayOutputStream
import java.nio.charset.Charset;                                                               // Charset
import java.util.Collections;                                                                  // Collections
import android.graphics.drawable.ColorDrawable;                                                // ColorDrawable
import java.util.Comparator;                                                                   // Comparator
import java.util.concurrent.locks.Condition;                                                   // Condition
import android.content.res.Configuration;                                                      // Configuration
import android.net.ConnectivityManager;                                                        // ConnectivityManager
import android.content.Context;                                                                // Context
import us.gov.socket.datagram;                                                                 // datagram
import java.util.Date;                                                                         // Date
import android.app.DialogFragment;                                                             // DialogFragment
import android.util.DisplayMetrics;                                                            // DisplayMetrics
import android.os.Environment;                                                                 // Environment
import java.io.File;                                                                           // File
import java.io.FileNotFoundException;                                                          // FileNotFoundException
import java.io.FileOutputStream;                                                               // FileOutputStream
import androidx.core.content.FileProvider;                                                     // FileProvider
import java.security.GeneralSecurityException;                                                 // GeneralSecurityException
import static us.gov.crypto.ripemd160.hash_t;                                                  // hash_t
import java.net.HttpURLConnection;                                                             // HttpURLConnection
import static us.gov.id.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import static us.stdint.*;                                                                     // *
import static us.tuple.*;                                                                      // *
import java.io.InputStream;                                                                    // InputStream
import java.io.InputStreamReader;                                                              // InputStreamReader
import android.content.Intent;                                                                 // Intent
import java.io.IOException;                                                                    // IOException
import static us.ko.is_ko;                                                                     // is_ko
import org.json.JSONArray;                                                                     // JSONArray
import org.json.JSONException;                                                                 // JSONException
import org.json.JSONObject;                                                                    // JSONObject
import java.security.KeyPair;                                                                  // KeyPair
import us.ko;                                                                                  // ko
import java.util.Locale;                                                                       // Locale
import java.util.concurrent.locks.Lock;                                                        // Lock
import android.util.Log;                                                                       // Log
import android.os.Looper;                                                                      // Looper
import android.view.Menu;                                                                      // Menu
import android.view.MenuItem;                                                                  // MenuItem
import android.net.NetworkInfo;                                                                // NetworkInfo
import static us.ko.ok;                                                                        // ok
import java.io.OutputStream;                                                                   // OutputStream
import java.io.OutputStreamWriter;                                                             // OutputStreamWriter
import us.pair;                                                                                // pair
import java.net.PasswordAuthentication;                                                        // PasswordAuthentication
import android.preference.PreferenceManager;                                                   // PreferenceManager
import java.io.PrintStream;                                                                    // PrintStream
import us.wallet.protocol;                                                                     // protocol
import us.wallet.trader.qr_t;                                                                  // qr_t
import java.util.Random;                                                                       // Random
import java.util.concurrent.locks.ReentrantLock;                                               // ReentrantLock
import android.content.res.Resources;                                                          // Resources
import android.content.SharedPreferences;                                                      // SharedPreferences
import android.os.StrictMode;                                                                  // StrictMode
import us.string;                                                                              // string
import android.net.wifi.SupplicantState;                                                       // SupplicantState
import android.telephony.TelephonyManager;                                                     // TelephonyManager
import java.util.Timer;                                                                        // Timer
import java.util.TimerTask;                                                                    // TimerTask
import android.widget.Toast;                                                                   // Toast
import android.media.ToneGenerator;                                                            // ToneGenerator
import java.util.TreeMap;                                                                      // TreeMap
import java.io.UnsupportedEncodingException;                                                   // UnsupportedEncodingException
import java.net.URL;                                                                           // URL
import android.net.wifi.WifiInfo;                                                              // WifiInfo
import android.net.wifi.WifiManager;                                                           // WifiManager

public final class app extends Application implements datagram_dispatcher_t.handler_t {


    public static boolean is_ui_thread() {
        return Looper.getMainLooper().isCurrentThread();
    }



    public interface progress_t {
        void on_progress(final String line);
    }

    @Override protected void attachBaseContext(Context base) {
        super.attachBaseContext(base);
        error_manager.setup(base, this);
    }

    @Override public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }

    public app() {
    }

    void abort(String reason) {
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(0);
    }

    public static class walletd_status_handler_t implements hmi_t.status_handler_t {

        public walletd_status_handler_t(app a_) {
            a = a_;
        }

        @Override public void on_status(ColorDrawable led_status, final String msg) {
            a.set_walletd_led(2, led_status);
        }

        app a;
    }

    static interface i18n_t {
        enum sid {
            unknown,
            app, pres, ehr, aireq, aires, send, new_, cat, inv, pay, rcpt, precontract, contract
        }
        String resolve(sid s);
    }

    static class i18n_en implements i18n_t {
        @Override
        public String resolve(sid s) {
            switch(s) {
                case app: return "Appointment";
                case pres: return "Prescription";
                case ehr: return "Electronic Health Record (EHR)";
                case aireq: return "A.I. Service referral";
                case aires: return "A.I. Service results";
                case send: return "Send";
                case new_: return "New";
                case cat: return "Catalogue";
                case inv: return "Invoice";
                case pay: return "Payment";
                case rcpt: return "Receipt";
                case contract: return "Contract";
                case precontract: return "Pre-contract";
            }
            return "unknown";
        }
    };

    static class i18n_es implements i18n_t {
        @Override public String resolve(sid s) {
            switch(s) {
                case app: return "Cita";
                case pres: return "Receta";
                case ehr: return "Historia medica (EHR)";
                case aireq: return "Volante servicio I.A";
                case aires: return "Resultados servicio I.A";
                case send: return "Enviar";
                case new_: return "Nuevo";
                case cat: return "Catalogo";
                case inv: return "Factura";
                case pay: return "Pago";
                case rcpt: return "Recibo";
                case contract: return "Contrato";
                case precontract: return "Pre-contrato";
            }
            return "desconocido";
        }
    };

    static i18n_t.sid i18n_sid(String s) {
        if (s.equals("app")) return i18n_t.sid.app;
        if (s.equals("pres")) return i18n_t.sid.pres;
        if (s.equals("ehr")) return i18n_t.sid.ehr;
        if (s.equals("aireq")) return i18n_t.sid.aireq;
        if (s.equals("aires")) return i18n_t.sid.aires;
        if (s.equals("send")) return i18n_t.sid.send;
        if (s.equals("new")) return i18n_t.sid.new_;
        if (s.equals("cat")) return i18n_t.sid.cat;
        if (s.equals("inv")) return i18n_t.sid.inv;
        if (s.equals("pay")) return i18n_t.sid.pay;
        if (s.equals("rcpt")) return i18n_t.sid.rcpt;
        if (s.equals("precontract")) return i18n_t.sid.precontract;
        if (s.equals("contract")) return i18n_t.sid.contract;
        return i18n_t.sid.unknown;
    }

    @Override public void onCreate() {
        super.onCreate();
        activity.a = (app) this;
        us.gov.crypto.ec.create_instance();
        locale.set(new Locale(locale.get_lang(this), locale.get_country(this)));
        locale.update(this, getResources().getConfiguration());
        String lang = locale.get_lang(this);
        if (lang != null && lang.equals("es")) {
            i18n = new i18n_es();
        }
        else {
            i18n = new i18n_en();
        }
        StrictMode.VmPolicy.Builder builder = new StrictMode.VmPolicy.Builder();
        StrictMode.setVmPolicy(builder.build());
        

        tone = new ToneGenerator(AudioManager.STREAM_MUSIC, 100);

//        hmi = null;
        int pwr = create_device_endpoints();
        if (device_endpoints == null) {
            abort("device_endpoints failure");
            return;
        }
        if (pwr != -1) {
            HMI_power_on(pwr, new pin_t(0), null);
        }
        else {
            Timer timer = new Timer();
            timer.schedule(new TimerTask() {
              @Override public void run() {
                runOnUiThread(new Runnable() {
                    @Override public void run() { 
                        launch_connections();
                    }
                });
              }
            }, 3000);
        }
    }

    void test_hmi() {
        if (!hmi_t.test()) {
            abort("failed hmi tests");
            return;
        }
    }

/*
    void test_device_endpoint() {
        device_endpoints_t x = new device_endpoints_t(this);

        blob_t blob = new blob_t(us.gov.crypto.base58.decode("3TpsNSjGp84MBxXgTBpnvffsZSnQaaTJF7qGcrD3i2Xstf4Py4LsiVW6ng27n8vWSBG1eG1UXSg5Dpo1ezfxUYaZm1DaLsFazVveUDxgx7fdoATTuWkB8fA"));
        if (blob.value == null) {
            assert false;
        }
        us.wallet.engine.wallet_connection_t wallet_connection = new us.wallet.engine.wallet_connection_t();
        blob_reader_t reader = new blob_reader_t(blob);
        ko r = reader.read(wallet_connection);
        if (is_ko(r)) {
            assert false;
        }
    }
*/


    public int create_device_endpoints() { // returns the index to poweron, -1 for none
//        if (device_endpoints != null) {
//            return -1;
//        }
        try {
            device_endpoints = new device_endpoints_t(this);
            return device_endpoints.init();
        }
        catch (Exception e) {
            device_endpoints = null;
        }
        return -1;
    }

    public void set_foreground_activity(activity ac, boolean up) {
        lock_active_ac.lock();
        try {
            if (up) {
                active_ac = ac;
            }
            else {
                if (active_ac == ac) {
                    active_ac = null;
                }
            }
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    void set_led(int daemon, int i, ColorDrawable color) { //0 gov 1 wallet
        if (daemon == 0) set_walletd_led(i, color);
        else set_govd_led(i, color);
    }

    void set_walletd_led(int i, ColorDrawable color) {
        lock_active_ac.lock();
        try {
            if (active_ac == null) {
                return;
            }
            if (active_ac.walletd_leds == null) {
                return;
            }
            active_ac.walletd_leds.set_led(i, color);
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    void set_walletd_leds_off() {
        lock_active_ac.lock();
        try {
            if (active_ac == null) {
                return;
            }
            if (active_ac.walletd_leds == null) {
                return;
            }
            active_ac.walletd_leds.set_all_off();
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    void set_govd_led(int i, ColorDrawable color) {
        lock_active_ac.lock();
        try {
            if (active_ac == null) {
                return;
            }
            if (active_ac.walletd_leds == null) {
                return;
            }
            if (active_ac.govd_leds != null) {
                active_ac.govd_leds.set_led(i, color);
            }
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    void set_govd_leds_off() {
        lock_active_ac.lock();
        try {
            if (active_ac == null) {
                return;
            }
            if (active_ac.walletd_leds == null) {
                return;
            }
            if (active_ac.govd_leds != null) {
                active_ac.govd_leds.set_all_off();
            }
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    static class walletd_led_handler implements busyled_t.handler_t {

        walletd_led_handler(app a_, int i_) {
            a = a_;
            i = i_;
        }

        @Override public void on_busy() {
            a.set_walletd_led(i, leds_t.led_green);
        }

        @Override public void on_idle() {
            a.set_walletd_led(i, leds_t.led_off);
        }

        int i;
        app a;
    }

    static class govd_led_handler implements busyled_t.handler_t {

        govd_led_handler(app a_, int i_) {
            a = a_;
            i = i_;
        }

        @Override public void on_busy() {
            a.set_govd_led(i, leds_t.led_green);
        }

        @Override public void on_idle() {
            a.set_govd_led(i, leds_t.led_off);
        }

        int i;
        app a;
    }

    int rnd(int min, int max) {
        return new Random().nextInt(1 + min + (max - min));
    }

    public void led_test__worker(int d) {
        boolean prev;
        lock_active_ac.lock();
        try {
            if (active_ac == null) return;
            if (d == 0) {
                prev = active_ac.leds_visible_wallet;
                active_ac.set_leds_visibility_wallet(true);
            }
            else {
                prev = active_ac.leds_visible_gov;
                active_ac.set_leds_visibility_gov(true);
            }
        }
        finally {
            lock_active_ac.unlock();
        }
        try {
            set_led(d, 0, leds_t.led_blue);
            set_led(d, 1, leds_t.led_blue);
            set_led(d, 2, leds_t.led_blue);
            Thread.sleep(rnd(2000, 2500));
            set_led(d, 0, leds_t.led_red);
            set_led(d, 1, leds_t.led_red);
            set_led(d, 2, leds_t.led_red);
            Thread.sleep(2000);
            set_led(d, 0, leds_t.led_amber);
            set_led(d, 1, leds_t.led_amber);
            set_led(d, 2, leds_t.led_amber);
            Thread.sleep(2000);
            set_led(d, 0, leds_t.led_green);
            set_led(d, 1, leds_t.led_green);
            set_led(d, 2, leds_t.led_green);
            Thread.sleep(2000);
            set_led(d, 0, leds_t.led_blue);
            set_led(d, 1, leds_t.led_blue);
            set_led(d, 2, leds_t.led_blue);
            Thread.sleep(2000);
            set_led(d, 2, leds_t.led_red);
            for (int i = 0; i < 5; ++i) {
                ColorDrawable s=leds_t.led_green;
                set_led(d, 0, s);
                set_led(d, 1, s);
                Thread.sleep(200 + 5 * i);
                s = leds_t.led_off;
                set_led(d, 0, s);
                set_led(d, 1, s);
                Thread.sleep(100 - 5 * i);
            }
            set_led(d, 2, leds_t.led_amber);
            for (int i = 5; i < 10; ++i) {
                set_led(d, 0, leds_t.led_green);
                set_led(d, 1, leds_t.led_off);
                Thread.sleep(200 + 5 * i);
                set_led(d, 0, leds_t.led_off);
                set_led(d, 1, leds_t.led_green);
                Thread.sleep(100 - 5 * i);
            }
            set_led(d, 2, leds_t.led_green);
            for (int i = 10; i < 15; ++i) {
                set_led(d, 0, leds_t.led_off);
                set_led(d, 1, leds_t.led_off);
                Thread.sleep(200 + 5 * i);
                set_led(d, 0, leds_t.led_green);
                set_led(d, 1, leds_t.led_green);
                Thread.sleep(100 - 5 * i);
            }
            set_led(d, 0, leds_t.led_off);
            set_led(d, 1, leds_t.led_off);
            set_led(d, 2, leds_t.led_off);
        }
        catch(Exception e) {
        }
        lock_active_ac.lock();
        try {
            if (active_ac == null) return;
            if (d == 0) {
                active_ac.set_leds_visibility_wallet(prev);
            }
            else {
                active_ac.set_leds_visibility_gov(prev);
            }
        }
        finally {
            lock_active_ac.unlock();
        }
        if (has_hmi()) {
            hmi().report_status();
        }
    }

    public void led_test(final int daemon) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                led_test__worker(daemon);
            }
        });
        thread.start();
    }

    public void led_test() {
        led_test(0);
        led_test(1);
    }

    public void use_personality(final hash_t tid, final String personality) {
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                hmi().command_trade(tid, "use_personality " + personality);
            }
        });
        thread.start();
    }

    public void start_protocol(final hash_t tid, final String procol) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                hmi().command_trade(tid, "start " + procol);
            }
        });
        thread.start();
    }


/*
    public void write_settings(String data) {
        try {
            OutputStreamWriter os = new OutputStreamWriter(openFileOutput(SETTINGS_JSON_PRIVATE_FILE, Context.MODE_PRIVATE));
            os.write(data);
            os.close();
        }
        catch (IOException e) {
            //error_manager.manage(e, e.getMessage() + "    " + e.toString());
        }
    }

    public String read_settings() {
        try {
            InputStream inputStream = getApplicationContext().openFileInput(SETTINGS_JSON_PRIVATE_FILE);
            if (inputStream == null) {
                return null;
            }
            InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
            String receiveString = "";
            StringBuilder stringBuilder = new StringBuilder();
            while ((receiveString = bufferedReader.readLine()) != null) {
                stringBuilder.append(receiveString);
            }
            inputStream.close();
            return stringBuilder.toString();
        }
        catch (FileNotFoundException e) {
        }
        catch (IOException e) {
            //error_manager.manage(e, e.getMessage() + "    " + e.toString());
        }
        return null;
    }

    public JSONArray read_settings2() {
        String sdata = read_settings();
        if (sdata == null) {
            return null;
        }
        JSONArray data;
        try {
            data = new JSONArray(sdata);
        }
        catch (JSONException e) {
            //error_manager.manage(e, e.getMessage() + "    " + e.toString());
            return null;
        }
        if (data == null) {
            return null;
        }
        return data;
    }

    public endpoint_t endpoint_from_settings() {
        JSONArray data = read_settings2();
        if (data == null) {
            return null;
        }
        try {
            for (int i = 0; i < data.length(); i++) {
                JSONObject o = data.getJSONObject(i);
                if (o != null) {
                    if (o.getString("default").equals("1")) {
                        return new endpoint_t(new shost_t(o.getString("lanip")), new port_t(o.getInt("lanport")), new channel_t(o.getInt("channel")));
                    }
                }
            }
        }
        catch (JSONException e) {
            //error_manager.manage(e, e.getMessage() + "    " + e.toString());
            return null;
        }
        return null;
    }
    boolean save(endpoint_t ep0) {
        assert ep0 != null;
        endpoint_t ep = new endpoint_t(ep0);
        ep.channel = new channel_t(((int)(ep.channel.value)));
        JSONArray data = read_settings2();
        if (data == null) {
            data = new JSONArray();
        }
        boolean found = false;
        try {
            for(int i = 0; i < data.length(); i++) {
                JSONObject o = data.getJSONObject(i);
                endpoint_t item = new endpoint_t(o);
                if (item.equals(ep)) {
                    o.remove("default");
                    o.remove("verified");
                    o.put("default", "1");
                    o.put("verified", "1");
                    found = true;
                }
                else { //Update others
                    o.remove("default");
                    o.put("default", "0");
                }
            }
            if (!found) {
                JSONObject settnew = new JSONObject();
                settnew.put("label", "Node @ " + ep.shost.value);
                settnew.put("wanip", ep.shost.value);
                settnew.put("lanip", ep.shost.value);
                settnew.put("wanport", ep.port.value);
                settnew.put("lanport", ep.port.value);
                settnew.put("channel", ep.channel.value);
                settnew.put("default", "1");
                settnew.put("verified", "1");
                data.put(settnew);
            }
            write_settings(data.toString());
        }
        catch(JSONException e) {
            return false;
        }
        return true;
    }
*/

/*
*/

/*
    public void launch_settings__worker() {
        lock_active_ac.lock();
        try {
            if (main == null) {
                return;
            }
            main.launch_settings__worker();
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    public void launch_settings() {
        lock_active_ac.lock();
        try {
            if (main == null) {
                return;
            }
            main.launch_settings();
        }
        finally {
            lock_active_ac.unlock();
        }
    }
*/
    public void runOnUiThread(Runnable uitask) {
        if (main == null) {
            return;
        }
        main.runOnUiThread(uitask);
    }



/*
    void init_hmi_(progress_t progress) {
        final app a = this;
        Thread worker = new Thread(new Runnable() {
            @Override public void run() {
                HMI_power_on(progress);
            }
        });
        worker.start();
    }
*/

    String r_(int id) {
        return getResources().getString(id);
    }

    public void new_trade(final hash_t parent_trade, final String datasubdir, final qr_t qr) {
        hmi().new_trade(parent_trade, datasubdir, qr);
/*
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                a.hmi().new_trade(parent_trade, datasubdir, qr);
            }
        });
        thread.start();
*/
        Toast.makeText(main, r_(R.string.newtrade) + "\n" + qr.to_string(), 600).show();
    }

    public void call_human(int code, final String info) {
/*
        switch(code) {
            case 1: //trade #tid received a chat update
                String tid = info;
                show_notification(1, info);
                //TODO: ... Show ! icon on every view there a tid is shown
            break;
       }
*/
    }

    public void go_trade__worker(final hash_t tid) {
        runOnUiThread(new Runnable() {
            @Override public void run() {
                a.go_trade(tid);
            }
        });
    }

    public void go_trade(final hash_t tid) {
        if (main == null) {
            return;
        }
        Intent intent = new Intent(main, trader.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        intent.putExtra("tid", tid.value);
        startActivity(intent);
    }

    public String balance(string s) {
        if (!has_hmi()) {
            return KO_89700;
        }
        final ko r = hmi().rpc_peer.call_balance(new uint16_t(0), s);
        String x = null;
        if (is_ko(r)) {
            x = a.hmi().rewrite(r);
        }
        return x;
    }

    public void toast__worker(final String msg) {
        lock_active_ac.lock();
        try {
            if (active_ac == null) {
            }
            else {
                active_ac.toast__worker(msg);
            }
        }
        finally {
            lock_active_ac.unlock();
        }
    }

    @Override public void on_push(hash_t target_tid, uint16_t code, byte[] payload) {
        switch(code.value) {
            case us.wallet.trader.trader_t.push_trade: {
                go_trade__worker(target_tid);
                return;
            }
            case us.wallet.trader.trader_t.push_chat: {
                runOnUiThread(new Runnable() {
                    @Override public void run() {
                        call_human(1, target_tid.encode());
                    }
                });
                break;
            }
            case us.gov.relay.pushman.push_ko: {
                string s = new string();
                blob_reader_t rder = new blob_reader_t(new blob_t(payload));
                ko r = rder.read(s);
                if (is_ko(r)) {
                    toast__worker("KO decode payload trade " + target_tid.encode() + ": " + r.msg);
                    return;
                }
                toast__worker("KO trade " + target_tid.encode() + ": " + s.value);
                return;
            }
            case us.gov.relay.pushman.push_ok: {
                string s = new string();
                blob_reader_t rder = new blob_reader_t(new blob_t(payload));
                ko r = rder.read(s);
                if (is_ko(r)) {
                    toast__worker("OK. later got " + r.msg);
                    return;
                }
                //toast__worker("OK trade " + target_tid.encode() + ": " + s.value);
                return;
            }
        }
    }

    public void HMI_power_on__worker(pin_t pin, progress_t progress) {
        HMI_power_on__worker(device_endpoints.cur_index.value, pin, progress);
    }

    public void HMI_power_on__worker(int pos, final pin_t pin, progress_t progress) {
        set_walletd_leds_off();
        set_govd_leds_off();
        if (progress == null) {
            progress = new app.progress_t() {
                @Override public void on_progress(final String report) {
                    toast__worker("progress: " + report);
                }
            };
        }
        if (has_hmi()) {
            progress.on_progress("Cannot power on other endpoint while " + device_endpoints.cur.name_ + " is already powereded ON.");
            return;
        }
        device_endpoints.poweron(this, pos, pin, progress);
        if (has_hmi()) {
            dispatchid = hmi().dispatcher.connect_sink(this);
        }
    }

    public void HMI_power_off__worker(boolean save_, progress_t progress) {
        HMI_power_off__worker(device_endpoints.cur_index.value, save_, progress);
    }

    public void HMI_power_off__worker(final int pos, boolean save_, final progress_t progress) {
        if (!has_hmi()) {
            dispatchid = -1;
        }
        if (dispatchid != -1) {
            hmi().dispatcher.disconnect_sink(dispatchid);
            dispatchid = -1;
        }
        device_endpoints.poweroff(this, pos, save_, progress);
        set_walletd_leds_off();
        set_govd_leds_off();
//        hmi = null;
    }

    public void HMI_power_on(final int pos, final pin_t pin, final progress_t progress) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                HMI_power_on__worker(pos, pin, progress);
            }
        });
        thread.start();
    }

    public void HMI_power_on(final pin_t pin, final progress_t progress) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                HMI_power_on__worker(pin, progress);
            }
        });
        thread.start();
    }

    public void HMI_power_off(final int pos, final boolean save_, final progress_t progress) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                HMI_power_off__worker(pos, save_, progress);
            }
        });
        thread.start();
    }

    public void HMI_power_off(final boolean save_, final progress_t progress) {
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                HMI_power_off__worker(save_, progress);
            }
        });
        thread.start();
    }

    public boolean is_HMI_poweron() {
        if (!has_hmi()) return false;
        return true;
    }

    final app a = (app) this;
    PrintStream cout = System.out;
    activity active_ac = null;
    main_activity main = null;

    Lock lock_active_ac = new ReentrantLock();
    //hmi_t hmi = null; ///current hmi

    public hmi_t hmi() {
        return device_endpoints.cur.hmi;
    }

    public boolean has_hmi() {
        return device_endpoints.cur.hmi != null;
    }
/*
    public void set_hmi(int position) {
        a.device_endpoints.set_cur(position);
        hmi = a.device_endpoints.cur.hmi;
    }
*/

    public String net_identifier() {
        ConnectivityManager cm;
        NetworkInfo info = null;
        try {
            cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
            info = cm.getActiveNetworkInfo();
        }
        catch (Exception e) {
            return ""; //e.printStackTrace();
        }
        if (info == null) {
            return "";
        }
        if (!info.isConnected()) {
            return "";
        }
        if (info.getType() == ConnectivityManager.TYPE_WIFI) {
            WifiManager wifiManager = (WifiManager) getSystemService(Context.WIFI_SERVICE);
            WifiInfo wifiInfo;
            wifiInfo = wifiManager.getConnectionInfo();
            if (wifiInfo.getSupplicantState() == SupplicantState.COMPLETED) {
                String ssid = wifiInfo.getSSID();
                ssid = ssid.replaceAll("\"", "");
                if (!ssid.equals("<unknown ssid>")) {
                    return ssid;
                }
            }
            return "wifi";
        }
        if (info.getType() == ConnectivityManager.TYPE_MOBILE) { 
            switch (info.getSubtype()) {
                case TelephonyManager.NETWORK_TYPE_GPRS:
                case TelephonyManager.NETWORK_TYPE_EDGE:
                case TelephonyManager.NETWORK_TYPE_CDMA:
                case TelephonyManager.NETWORK_TYPE_1xRTT:
                case TelephonyManager.NETWORK_TYPE_IDEN:
                case TelephonyManager.NETWORK_TYPE_GSM:
                     return "2G";
                case TelephonyManager.NETWORK_TYPE_UMTS:
                case TelephonyManager.NETWORK_TYPE_EVDO_0:
                case TelephonyManager.NETWORK_TYPE_EVDO_A:
                case TelephonyManager.NETWORK_TYPE_HSDPA:
                case TelephonyManager.NETWORK_TYPE_HSUPA:
                case TelephonyManager.NETWORK_TYPE_HSPA:
                case TelephonyManager.NETWORK_TYPE_EVDO_B:
                case TelephonyManager.NETWORK_TYPE_EHRPD:
                case TelephonyManager.NETWORK_TYPE_HSPAP:
                case TelephonyManager.NETWORK_TYPE_TD_SCDMA:
                    return "3G";
                case TelephonyManager.NETWORK_TYPE_LTE:
                case TelephonyManager.NETWORK_TYPE_IWLAN:
                case 19:
                    return "4G";
                case TelephonyManager.NETWORK_TYPE_NR:
                    return "5G";
                default:
                    return "mobile";
            }
        }
        return "unknown";
    }


    public void launch_connections() {
        if (main == null) {
            return;
        }
        main.manage_connections();
    }

    public void launch_connection_settings() {
        main.go_conf(device_endpoints.cur_index.value);
    }

    public void toggle_poweron() {
        app.progress_t progress = new app.progress_t() {
            @Override public void on_progress(final String report) {
                toast__worker(report);
            }
        };
        if (!has_hmi()) {
            HMI_power_on(new pin_t(0), progress);
            return;
        }
        HMI_power_off(true, progress);
    }



    public static String KO_68874 = "KO 68874 Invalid endpoint.";
    public static String KO_89700 = "KO 89700 HMI is off.";

    device_endpoints_t device_endpoints = null;
    //device_endpoint_t cur;
    //ArrayList<cryptocurrency> shit

    //public String homedir = null;
//    public ArrayList<String> notification_trades_id =  new ArrayList<String>();
    public i18n_t i18n;
    ToneGenerator tone;
    int dispatchid = -1;

}


