#include "counters_t.h"
#if CFG_COUNTERS == 1

#define loglevel "gov/engine/auth"
#define logclass "counters_t"
#include <us/gov/engine/logs.inc>

using namespace std;
using namespace us::gov;
using namespace us::gov::engine::auth;
using c = us::gov::engine::auth::counters_t;
using us::ko;

void c::dump(ostream& os) const {
    os << "basic_auth_completed " << basic_auth_completed << '\n';
    os << "not_authorized " << not_authorized << '\n';
    os << "invalid_net_address " << invalid_net_address << '\n';
    os << "sysop_connections " << sysop_connections << '\n';
    os << "node_connections " << node_connections << '\n';
    os << "out_connections " << out_connections << '\n';
    os << "hall_connections " << hall_connections << '\n';
}

#endif

