#include <us/gov/config.h>

#include "rpc_peer_t.h"
#include "types.h"
#include "rpc_daemon_t.h"

#define loglevel "gov/engine"
#define logclass "rpc_daemon_t"
#include "logs.inc"

using namespace us::gov::engine;
using c = us::gov::engine::rpc_daemon_t;

c::rpc_daemon_t(channel_t channel, dispatcher_t* dispatcher): b(channel, dispatcher) {
    api_v = CFG_API_V__GOV;
    assert(api_v != 0);
    log("set api_v", +api_v);
}

c::~rpc_daemon_t() {
}

/*
socket::client* c::create_client() {
    log("create_client");
    return new rpc_peer_t(*this);
}
*/

void c::dump(const string& prefix, ostream& os) const {
    os << prefix << "engine::rpc_daemon_t\n";
}

void c::dump_all(const string& prefix, ostream& os) const {
    dump(prefix, os);
    b::dump_all(prefix, os);
}

