#pragma once
#include "addr_t.h"

namespace us::gov::engine {

    using namespace std;

    struct tcp_addr: addr_t {
        using b = addr_t;

        static constexpr char id{'A'};
        virtual void to_stream(ostream&) const override;
        static addr_t* from_stream(istream&);

        string address;
        uint16_t port;
    };

}

