#include "protocol.h"
#include "peer_t.h"
#include "rpc_daemon_t.h"

#define loglevel "gov/id"
#define logclass "rpc_daemon_t"
#include "logs.inc"

using namespace us::gov::id;
using c = us::gov::id::rpc_daemon_t;

/*
socket::client* c::create_client() {
    log("KO 78673 specialize peer");
    assert(false);
    return nullptr;
//    log("create_client");
//    return new peer_t(*this);
}
*/

void c::dump(const string& prefix, ostream& os) const {
    os << prefix << "id::rpc_daemon_t: caller public key: " << get_keys().pub << " addr " << get_keys().pub.hash() << '\n';
}

void c::dump_all(const string& prefix, ostream& os) const {
    dump(prefix, os);
    b::dump_all(prefix, os);
}

