#include "rpc_daemon_t.h"
#include "protocol.h"
#include "rpc_peer_t.h"

#define loglevel "gov/peer"
#define logclass "rpc_peer_t"
#include "logs.inc"
#include <us/gov/socket/dto.inc>

using namespace us::gov::peer;
using c = us::gov::peer::rpc_peer_t;

void c::dump(const string& prefix, ostream& os) const {
    os << prefix << "  rpc_peer\n";
}

void c::dump_all(const string& prefix, ostream& os) const {
    dump(prefix, os);
    b::dump_all(prefix, os);
}

#ifdef has_us_gov_peer_api
    #include <us/api/generated/gov/c++/peer/cllr_rpc-impl>
#endif

