package us;
import static us.gov.id.types.*;                                                               // *
import static us.gov.io.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import static us.stdint.*;                                                                     // *
import us.ko;                                                                                  // ko
import static us.ko.ok;                                                                        // ok

public class CFG {

    public static final String LOGDIR = "/var/log/plebble";

    public static final short TEST = 0;
    public static final String COPYRIGHT_LINE = "2017-2022 root1m3@plebble.us 4NwEEwnQbnwB7p8yCBNkx9uj71ru";
    public static final String COPYRIGHT_LINE2 = "This program comes with ABSOLUTELY NO WARRANTY. For details type 'show w'.";
    public static final String COPYRIGHT_LINE3 = "This is free software, and you are welcome to redistribute it under certain conditions. Type 'show c' for details.";
    public static final String LICENSE_FILE = "/var/plebble/LICENSE";
    public static final String AUTOMATIC_UPDATES_PUBKEY = "ysMCfLj9wt9ZdaaRaNtCS2WUJh8T5kvrh4ihHARKiTH1";
    public static final String NODEMASTER_PUBKEY = "";
    public static final String AUTOMATIC_UPDATES_ACCOUNT = "4NwEEwnQbnwB7p8yCBNkx9uj71ru";
    public static final String BRANDID = "PuxQ2g";
    public static final String PLATFORM = "plebble";
    public static final String DATADIR = ".plebble";
    public static final int LAYOFF_DAYS = 20;
    public static final String UGAS = "WATER";
    public static final String LGAS = "water";
    public static final short COUNTERS = 0;
    public static final short CONNECTION_LOG = 0;
    public static final channel_t CHANNEL = new channel_t(0);
    public static final int MAX_SUBSIDY = 500000000;
    public static final int MAX_SIZE_DATAGRAM = 60000000;
    public static final short LOGS = 0;
    public static final port_t PORT = new port_t(16672);
    public static final pport_t PPORT = new pport_t(16672);
    public static final port_t WALLET_PORT = new port_t(16673);
    public static final pport_t WALLET_PPORT = new pport_t(16673);
    public static final int MAX_NODES = 200;
    public static final int REPORT_REASON = 1;
    public static final int FCGI = 0;
    public static final int DEBUG = 0;
    public static final int HMI_READY_TIMEOUT_SECS = 1;
    public static final int AUTH_TIMEOUT_SECS = 5;
    public static final int SENDQ_SIZE = 100;
    public static final int SENDQ_WMH = 1000;
    public static final int SENDQ_SCHUNK = 1500;
    public static final int DGRAM_ROUNDTRIP_TIMEOUT_SECS = 5;
    public static final blob_t.version_t BLOB_VERSION = new blob_t.version_t((short)10);
    public static final String ANDROID_BLOB_ID = "F5a1povb";
    public static final api_v_t API_V__GOV = new api_v_t(8);
    public static final api_v_t API_V__WALLET = new api_v_t(11);
    public static final version_fingerprint_t MONOTONIC_VERSION_FINGERPRINT = new version_fingerprint_t(9);

    public static class network_topology_t {
        public String TYPE;
        public boolean PUBLIC;
        public boolean PRIVATE;
        public boolean PERMISSIONLESS;
        public boolean PERMISSIONED;
        public boolean MESH;
        public boolean RING;

        public network_topology_t(String type_) {
            TYPE = type_;
            String v[] = type_.split("_");
            assert v.length == 3;
            if (v[0].equals("PUBLIC")) {            
                PUBLIC = true;
            }
            else if (v[0].equals("PRIVATE")) {            
                PUBLIC = false;
            }
            else {
                System.err.println("KO 79893");
                System.exit(1);
            }
            PRIVATE = !PUBLIC;

            if (v[1].equals("PERMISSIONLESS")) {            
                PERMISSIONLESS = true;
            }
            else if (v[1].equals("PERMISSIONED")) {            
                PERMISSIONLESS = false;
            }
            else {
                System.err.println("KO 79893");
                System.exit(1);
            }
            PERMISSIONED = !PERMISSIONLESS;
            if (v[2].equals("MESH")) {            
                MESH = true;
            }
            else if (v[2].equals("RING")) {            
                MESH = false;
            }
            else {
                System.err.println("KO 79893");
                System.exit(1);
            }
            RING=!MESH;
        }
    }

    public static final network_topology_t NETWORK_TOPOLOGY = new network_topology_t("PUBLIC_PERMISSIONLESS_MESH");



















}

