package us.gov.socket;
import java.util.concurrent.atomic.AtomicInteger;                                              // AtomicInteger
import us.CFG;                                                                                 // CFG

public class busyled_t {



    public static interface handler_t {
        void on_busy();
        void on_idle();
    }

    public busyled_t() {
    }

    public busyled_t(boolean on) {
        if (on) set();
    }


    public void set() {
        int r = ref.getAndIncrement();
        if (r != 0) {
            return;
        }
        if (handler == null) {
            return;
        }
        handler.on_busy();
    }

    public void reset() {
        int r = ref.getAndDecrement();
        if (r != 1) {
            return;
        }
        if (handler == null) {
            return;
        }
        handler.on_idle();
    }

    public void set_handler(handler_t h) {
        handler = h;
    }

    private handler_t handler = null;
    private AtomicInteger ref = new AtomicInteger(0);
}

