package us.wallet.trader.cert;
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import static us.gov.io.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import static us.ko.*;                                                                         // *
import static us.stdint.*;                                                                     // *
import us.ko;                                                                                  // ko
import us.pair;                                                                                // pair
import static us.gov.io.types.blob_t.serid_t;                                                  // serid_t
import us.string;                                                                              // string

public abstract class expiry_doc_t extends doc0_t {


    public expiry_doc_t() {
    }

    @Override public serid_t serial_id() { return serid_t.no_header; }

    @Override public int blob_size() {
        return super.blob_size() + blob_writer_t.blob_size(expiry);
    }

    @Override public void to_blob(blob_writer_t writer) {
        super.to_blob(writer);
        writer.write(expiry);
    }

    @Override public ko from_blob(blob_reader_t reader) {
        {
            ko r = super.from_blob(reader);
            if (is_ko(r)) return r;
        }
        {
            expiry = new ts_t();
            ko r = reader.read(expiry);
            if (is_ko(r)) return r;
        }
        return ok;
    }

    public ts_t expiry;

}

