package us.wallet.trader;
import java.io.BufferedReader;                                                                 // BufferedReader
import java.io.ByteArrayInputStream;                                                           // ByteArrayInputStream
import java.io.ByteArrayOutputStream;                                                          // ByteArrayOutputStream
import us.CFG;                                                                                 // CFG
import java.util.HashMap;                                                                      // HashMap
import us.stdint.*;                                                                            // *
import java.io.InputStream;                                                                    // InputStream
import java.io.InputStreamReader;                                                              // InputStreamReader
import static us.ko.is_ko;                                                                     // is_ko
import us.ko;                                                                                  // ko
import java.util.Map;                                                                          // Map
import static us.ko.ok;                                                                        // ok
import java.io.OutputStream;                                                                   // OutputStream
import us.pair;                                                                                // pair
import java.io.PrintStream;                                                                    // PrintStream
import java.util.Scanner;                                                                      // Scanner
import java.util.TreeMap;                                                                      // TreeMap

@SuppressWarnings("serial")
public class data_t extends TreeMap<String, String> {


    public String find(String key) {
        return get(key);
    }

    public void emplace(String k, String v) {
        put(k, v);
    }

    public ko from(String s) {
        InputStream is = new ByteArrayInputStream(s.getBytes());
        return from(is);
    }

    public ko from(InputStream is) {
        clear();
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(is))) {
            while (reader.ready()) {
                String line = reader.readLine();
                if (line.isEmpty()) continue;
                String[] kv = line.split(" ", 2);
                if (kv.length != 2) return new ko("KO 50045");
                if (kv[0].isEmpty()) {
                    clear();
                    return new ko("KO 66058");
                }
                put(kv[0], kv[1]);
            }
        }
        catch (Exception e) {
        }
        return ok;
    }

    public void dump(final String pfx, PrintStream os) {
        dump_(pfx, os);
    }

    public void dump_(final String pfx, PrintStream os) {
        for (Map.Entry<String, String> entry: entrySet()) {
            os.println(pfx + "'" + entry.getKey() + "': " + entry.getValue());
        }
    }

}

