#pragma once
#include "r2r_t.h"
#include <us/wallet/wallet/txlog_t.h>
#include <us/gov/crypto/ripemd160.h>

namespace us::test {

    using namespace std;

    struct network;
    struct node;

    struct w2w_t: r2r_t {
        using b = r2r_t;
        using track_t = us::wallet::wallet::track_t;
        using hash_t = us::gov::crypto::ripemd160::value_type;

        w2w_t(network& n): b(n) {}

        track_t init_transfer(node& sender, node& rcpt);
        void cancel_transfer_by_sender1(node& sender, node& rcpt, track_t track);
        void cancel_transfer_by_sender2(node& sender, node& rcpt, track_t track);
        void confirm_transfer(node& sender, node& rcpt, track_t track);

        void test(node&, node&);

        void test_10(node&, node&);
        //void test_20(node&, node&);
        //void test_25(node&, node&);
        void test_30(node&, node&);

        void run();

    };

}

