#pragma once
#include <cassert>

#include <us/gov/config.h>
#include <us/gov/relay/rpc_daemon_t.h>

#include "types.h"

namespace us::wallet::engine {

    struct rpc_daemon_t: gov::relay::rpc_daemon_t {
        using b = gov::relay::rpc_daemon_t;

        rpc_daemon_t(channel_t channel, dispatcher_t*);
        ~rpc_daemon_t() override;

        socket::client* create_client() override { assert(false); return nullptr; }

    };

}

