#include "roles_t.h"

#include <us/gov/io/cfg0.h>
#include <us/gov/crypto/base58.h>

#include "trader_t.h"

#define loglevel "wallet/trader"
#define logclass "roles_t"
#include <us/gov/logs.inc>

using namespace us::wallet::trader;
using c = us::wallet::trader::roles_t;

void c::dump(const string& pfx, ostream& os) const {
    lock_guard<mutex> lock(mx);
    for (auto& i: *this) {
        os << pfx << i.first << ' ' << i.second << '\n';
    }
}

