#pragma once
#include <string>
#include <map>
#include <sstream>
#include <mutex>
#include <chrono>
#include <fstream>
#include <unordered_map>

#include <us/gov/io/factory.h>

#include <us/wallet/trader/business.h>
#include <us/wallet/trader/ch_t.h>
#include <us/wallet/trader/trader_t.h>

#include "workflow_t.h"
#include "item_t.h"

namespace us::wallet::trader::workflow {

    struct business_t: us::wallet::trader::business_t {
        using b = us::wallet::trader::business_t;
        using ch_t = us::wallet::trader::ch_t;

    public:
        business_t();
        ~business_t() override;

    };

}
