package us.example;
import us.ko;
import static us.ko.*;
import static us.stdint.uint16_t;
import us.string;

public class api_balance extends example_base {

    @Override public String description() {
        return "obtain wallet balance and print via rpc API";
    }

    @Override public ko run(String[] args) {

        bring_up();

        System.out.println("\nWallet balance:");
        uint16_t detailed = new uint16_t(0); //level of detail 0|1|2
        string data = new string();
        ko r = rpc_daemon.get_peer().call_balance(detailed, data);
        if (is_ko(r)) {
            System.err.println("Error: " + r.msg);
            System.exit(1);
        }
        System.out.println(data.value);

        shut_down();
        return ok;
    }

}

