#pragma once
#include "output_t.h"
#include <us/gov/io/seriable_vector.h>
#include <us/gov/cash/sigcode_section_t.h>

namespace us::gov::cash::tx {

    struct outputs_t final: io::seriable_vector<output_t> {
        using b = io::seriable_vector<output_t>;

        void write_sigmsg(sigmsg_hasher_t&, const sigcode_section_t&) const;
        cash_t total() const;
        void write_pretty(const string& prefix, ostream&) const;
    };

}

