#pragma once
#include <us/gov/relay/rpc_peer_t.h>
#include "api.h"
#include "types.h"

namespace us { namespace wallet { namespace engine {

    struct rpc_peer_t: us::gov::relay::rpc_peer_t, caller_api  {
        using b = us::gov::relay::rpc_peer_t;

        using b::rpc_peer_t;
        bool process_work(datagram*) override;

        svc_t translate_svc(svc_t svc0, bool inbound) const override;

        #include <us/api/generated/wallet/c++/engine/cllr_override>
        #include <us/api/generated/wallet/c++/pairing/cllr_override>
        #include <us/api/generated/wallet/c++/wallet/cllr_override>
        #include <us/api/generated/wallet/c++/r2r/cllr_override>
    };

}}}

