#pragma once
#include <string>
#include <iostream>
#include <mutex>

#include <us/gov/ko.h>
#include <us/gov/io/seriable_vector.h>

namespace us::wallet::trader {

    struct trader_t;

    struct roles_t: us::gov::io::seriable_vector<pair<string, string>> {
        using b = us::gov::io::seriable_vector<pair<string, string>>;
        void dump(const string& pfx, ostream&) const;
        mutable mutex mx;
    };

}

