#pragma once
#include <vector>
#include <iostream>

#include <us/gov/ko.h>
#include <us/gov/io/seriable_vector.h>
#include <us/wallet/trader/protocol_selection_t.h>

namespace us::wallet::trader::bootstrap {

    struct protocols_t: us::gov::io::seriable_vector<protocol_selection_t> {
        using b = us::gov::io::seriable_vector<protocol_selection_t>;
        using item = protocol_selection_t;

        using b::seriable_vector;

        static protocols_t filter_common(protocols_t, protocols_t);
        void dump(ostream&) const;
        void uniq();

    };

}
    
