extern "C" {

    c* uswallet_business_create(int if_version) {
        if (if_version != us::wallet::trader::business_t::interface_version) {
            auto r = "KO 43731 Interfaces mismatch.";
            log(r, "Requested interface", if_version, "but I expose version", us::wallet::trader::business_t::interface_version);
            return nullptr;
        }
        return new c();
    }

    void uswallet_business_destroy(c* p) {
        log("destroy business");
        delete p;
    }

}

