#pragma once
#include <us/gov/types.h>
#include <us/gov/io/seriable.h>

namespace us::wallet::wallet {

    struct tx_make_p2pkh_input: us::gov::io::seriable {
        tx_make_p2pkh_input() {}

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t src_addr{0};
        hash_t rcpt_addr;
        cash_t amount;
        hash_t token;
    };

}

