package plebble.trader;
import android.util.AttributeSet;                                                              // AttributeSet
import android.graphics.BitmapFactory;                                                         // BitmapFactory
import android.graphics.Bitmap;                                                                // Bitmap
import android.os.Bundle;                                                                      // Bundle
import android.content.Context;                                                                // Context
import us.gov.socket.datagram;                                                                 // datagram
import us.wallet.trader.data_t;                                                                // data_t
import static us.gov.crypto.ripemd160.hash_t;                                                  // hash_t
import android.widget.ImageView;                                                               // ImageView
import static us.stdint.*;                                                                     // *
import static us.tuple.*;                                                                      // *
import us.gov.crypto.ripemd160.*;                                                              // *
import us.stdint.*;                                                                            // *
import us.tuple.*;                                                                             // *
import us.ko;                                                                                  // ko
import android.view.LayoutInflater;                                                            // LayoutInflater
import android.widget.LinearLayout;                                                            // LinearLayout
import static us.ko.ok;                                                                        // ok
import us.pair;                                                                                // pair
import android.widget.Toast;                                                                   // Toast
import android.view.ViewGroup;                                                                 // ViewGroup
import android.view.View;                                                                      // View

public class logo_view extends LinearLayout {


    public logo_view(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public void init(role_fragment rf_) {
        rf = rf_;
        banner = findViewById(R.id.banner);
        banner.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                banner_clicked();
            }
        });
    }

    void querylogo() {
        if (tries > 3) {
            Toast.makeText(rf.getActivity().getApplicationContext(), getResources().getString(R.string.givingupretrievinglogo), 6000).show();
            return;
        }
        tries++;
        rlogo = null;
        rf.a.hmi().command_trade(rf.tr.tid, "request logo");
    }

    void loadlogo() {
        if (rlogo != null) {
            return;
        }
        rf.tr.get_sourceshit("logo", rf.getActivity().getApplicationContext());
    }

    public void setlogo(final byte[] l) {
        rf.getActivity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
                rlogo = BitmapFactory.decodeByteArray(l, 0, l.length);
                if (rlogo == null) {
                    rlogo = null;
                }
                else {
                    try {
                        Bitmap sb = Bitmap.createScaledBitmap(rlogo, banner.getWidth(), banner.getHeight(), false);
                        if (sb == null) {
                            rlogo = null;
                        }
                        else {
                            rlogo = sb;
                        }
                    }
                    catch (Exception e) {
                        error_manager.manage(e, e.getMessage() + "    " + e.toString());
                        rlogo = null;
                    }
                }
                refresh();
            }
        });
    }

    public void banner_clicked() {
    }

    public boolean refresh() {
        data_t data = rf.tr.get_data();
        assert data != null;

        boolean haslogo = false;
        String logoval = data.find("logo");
        if (logoval != null) {
            if (logoval.equals("Y")) {
                haslogo = true;
            }
        }
        if (haslogo) {
            if (rlogo != null) {
                banner.setImageBitmap(rlogo);
            }
            else {
                loadlogo();
            }
        }
        else {
            tries = 0;
            querylogo();
        }
        return true;
    }

    View v = null;
    public Bitmap rlogo = null;
    public ImageView banner;
    int tries = 0;
    role_fragment rf;

}

