package plebble.trader;
import androidx.core.app.ActivityCompat;                                                       // ActivityCompat
import android.app.Activity;                                                                   // Activity
import android.app.AlertDialog;                                                                // AlertDialog
import java.util.Arrays;                                                                       // Arrays
import android.os.Build;                                                                       // Build
import java.io.ByteArrayOutputStream;                                                          // ByteArrayOutputStream
import androidx.core.content.ContextCompat;                                                    // ContextCompat
import android.content.Context;                                                                // Context
import android.content.DialogInterface;                                                        // DialogInterface
import java.io.File;                                                                           // File
import java.io.FileOutputStream;                                                               // FileOutputStream
import androidx.core.content.FileProvider;                                                     // FileProvider
import static android.Manifest.permission.*;                                                   // *
import android.content.Intent;                                                                 // Intent
import static us.ko.is_ko;                                                                     // is_ko
import us.ko;                                                                                  // ko
import android.Manifest;                                                                       // Manifest
import androidx.annotation.NonNull;                                                            // NonNull
import static us.ko.ok;                                                                        // ok
import android.content.pm.PackageManager;                                                      // PackageManager
import us.pair;                                                                                // pair
import android.provider.Settings;                                                              // Settings
import us.string;                                                                              // string
import java.util.Timer;                                                                        // Timer
import java.util.TimerTask;                                                                    // TimerTask
import android.widget.Toast;                                                                   // Toast
import android.net.Uri;                                                                        // Uri
import java.time.Instant;
import java.time.Duration;

public class sw_updates_t {

    static ko KO_60599 = new ko("KO 60599 Permissions problem.");



    void toast(String m) {
        if (activity.a.main == null) {
            return;
        }
        activity.a.main.runOnUiThread(new Runnable() {
            @Override public void run() {
                Toast.makeText(activity.a.main, m, 6000).show();
            }
        });
    }

    public sw_updates_t(app a_, hmi_t hmi_, cfg_android_private_t cfg_private_, cfg_android_public_t cfg_public_) {
        a = a_;
        hmi = hmi_;
        cfg_private = cfg_private_;
        cfg_public = cfg_public_;

        clean_update();
//        query_newapk_hash(); //setup_curapk();
    }

    //public String get_curapk() {
    //    return curapk;
    //}

    public void forget_curapk() {
        //curapk = "";
        clean_update();
    }

    void clean_update() {
//        cfg_private.delete_file("newapk_name");
        //is_updateavailable = false;
        cfg_private.delete_file("newapk_content");
//        cfg_private.delete_file("newapk_by");
    }

/*
    void boot_first_time() {
        if (!cfg_private.file_exists2("newapk_by")) { //I must be its first launch
            return;
        }
        String newapk_by = cfg_private.read_file_string("newapk_by");
        if (newapk_by == null || newapk_by.isEmpty()) {
            clean_update();
            return;
        }
        if (newapk_by.equals(us.vcs.apkfilename())) {
            toast("Unexpected version, did the apk fail to install? curapk " + curapk + " name " + us.vcs.version_name + " newapk_by " + newapk_by);
            is_updateavailable = true;
            return;
        }
        curapk = cfg_private.read_file_string("newapk");
        if (curapk == null || curapk.isEmpty()) {
            clean_update();
            return;
        }
        {
            ko ret = cfg_private.write_file("curapk", curapk);
            if (is_ko(ret)) {
                toast(ret.msg);
                clean_update();
                return;
            }
        }
        clean_update();
        toast("New version from apk " + curapk + " " + us.vcs.version_name + ". Release notes:");
        is_updateavailable = false;
    }
*/

//    ko setup_curapk() {
/*
    pair<ko, string> query_apk_hash() {
//        curapk = cfg_private.read_file_string("curapk");
//        if (curapk == null || curapk.isEmpty()) {
        us.wallet.cli.rpc_peer_t.get_component_hash_in_t o_in = new us.wallet.cli.rpc_peer_t.get_component_hash_in_t(new string("android"), new string(us.vcs.apkfilename()));
        pair<ko, string> ans = new pair<ko, string>(ok, new string());
        ans.first = hmi.rpc_peer.call_get_component_hash(o_in, ans.second);
        return ans;
*/
/*
        if (is_ko(r)) {
//            curapk = "";
            ans.first = r;
            return ans;
        }
        return ans;
*/
//        curapk = ans.value;
//        return cfg_private.write_file("curapk", curapk);
//        }
        //boot_first_time();
//    }

    private static String[] PERMISSIONS_STORAGE = {Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};
    private static final int REQUEST_EXTERNAL_STORAGE = 1832;

    public boolean verify_permissions(String[] permissions) {        // Check if we have write permission
        for (String str : permissions) {
            if (ContextCompat.checkSelfPermission(a.getApplicationContext(), str) != PackageManager.PERMISSION_GRANTED) {
                return false;
            }
        }
        return true;
    }

    public void ask_permission(int req_code, String[] permissions, String rationale) {
        if (a.main == null) {
            return;
        }
        if (ActivityCompat.shouldShowRequestPermissionRationale(a.main, permissions[0])) {
            new AlertDialog.Builder(a.main).setTitle("Info about automatic updates.")
                .setMessage(rationale)
                .setIcon(android.R.drawable.ic_dialog_info).show();
        }
        ActivityCompat.requestPermissions(a.main, permissions, req_code);
    }

    ko download_apk() {
        //is_updateavailable = false;
        if (!verify_permissions(PERMISSIONS_STORAGE)) {
            if (a.main != null) {
                a.main.runOnUiThread(new Runnable() {
                    @Override public void run() {
                        ask_permission(REQUEST_EXTERNAL_STORAGE, PERMISSIONS_STORAGE, "Please Grant access to external storage. This is needed for temporary storage of apk files (software updates).");
                    }
                });
            }
            return KO_60599;
        }
        if (!cfg_public.is_external_storage_writable()) {
            ko r = new ko("KO 78695 External storage is not writable");
            return r;
        }
        if (hmi == null || hmi.rpc_peer == null) {
            ko r0 = new ko("KO 60069 HMI is not active. Aborting download sw-updates.");
            return r0;
        }
        //if (is_updateavailable) {
        //    return ok;
        //}
        //if (cfg_private.file_exists2("newapk_by")) {
        //    is_updateavailable = true;
        //    return ok;
        //}
/*
        pair<ko, string> apkhash = query_apk_hash()
        if (is_ko(apkhash.first)) {
            return apkhash.first;
        }
        if (apkhash.second.value == null) {
            ko r0 = new ko("KO 60302 .");
            return r0;
        }
*/
        string apkfilename = new string(us.vcs.apkfilename());
//        ByteArrayOutputStream os = new ByteArrayOutputStream();
        us.wallet.cli.rpc_peer_t.get_component_update_in_t o_in = new us.wallet.cli.rpc_peer_t.get_component_update_in_t(new string(CFG.blob_id), new string("android"), apkfilename);
        us.wallet.cli.rpc_peer_t.get_component_update_out_dst_t o_out = new us.wallet.cli.rpc_peer_t.get_component_update_out_dst_t();
        {
            ko r = hmi.rpc_peer.call_get_component_update(o_in, o_out);
            if (is_ko(r)) {
                return r;
            }
        }
        if (o_out.vcsname.value.isEmpty()) {
            ko r = new ko("KO 10992 Unexpected empty filename.");
            return r;
        }
        if (o_out.vcsname.value.equals(apkfilename.value)) {
            //is_updateavailable = false;
            return new ko("KO 78868 No newer update blob.");
        }

        if (o_out.bin_pkg.value == null) {
            ko r = new ko("KO 10993 file is null.");
            return r;
        }
        if (o_out.bin_pkg.value.length < 1000000) {
            ko r = new ko("KO 10994 Suspicious length suggests truncated file." + o_out.bin_pkg.value.length);
            return r;
        }
        synchronized (cfg_android_public_t.downloads_dir_lock_t) {
            ko r = cfg_public.write_public_file("newapk_content", o_out.bin_pkg.value);
            if (is_ko(r)) {
                return r;
            }
        }
/*
        {
            ko r = cfg_private.write_file("newapk_name", o_out.file.value);
            if (is_ko(r)) {
                return r;
            }
        }
*/
/*
        {
            ko r = cfg_private.write_file("newapk_by", us.vcs.apkfilename());
            if (is_ko(r)) {
                return r;
            }
        }
        */
//        is_updateavailable = true;
        return ok;
    }

    void check(boolean informok) {
        a.main.runOnUiThread(new Runnable() {
            @Override public void run() {
                ask_install();
/*
                if (is_updateavailable) {
                }
                else {
                    if (informok) {
                        toast(a.getResources().getString(R.string.systemisuptodate));
                    }
                }
*/
            }
        });

//        if (a.main == null) return;

    }

/*
    Timer timer;

    public ko start() {
        timer = new Timer();
        timer.schedule(new TimerTask() {
                @Override public void run() {
                    check(false);
                }
            }, 2 * 1000, 8 * 60 * 60 * 1000); //check on start app and every 8 hours
        return ok;
    }

    public void stop() {
        if (timer == null) return;
        timer.cancel();
        timer = null;
    }

    public void join() {
    }
*/

    public boolean need_install_local_apk() {
        if (CFG.appstore_edition == 1) {
            return false;
        }
        if (!cfg_public.public_file_exists("newapk_content")) {
            return false;
        }
        return true;
    }

    public void ask_install() {
        if (a.active_ac == null) {
            return;
        }
        String[] options = {"Install now.", "Remind me later."};
        final sw_updates_t i = this;
        new AlertDialog.Builder(a.active_ac).setTitle("An update of the app " + CFG.app_name + " is ready to install...")
            .setItems(options, new DialogInterface.OnClickListener() {
                @Override public void onClick(DialogInterface dialog, int which) {
                    switch(which) {
                        case 0:
                            i.do_inst_ask_permission(a.active_ac);
                            break;
                        case 1:
                            user_selected_remind_me_later = Instant.now();
                            break;
                    }
                }
            })
            .setIcon(android.R.drawable.ic_dialog_alert).show();
    }

    public ko do_inst_local(activity ac) {

        {
            ko r = download_apk();
            if (is_ko(r)) { //retry in 
                return r;
            }
        }

        if (!need_install_local_apk()) {
            ac.toast(a.getResources().getString(R.string.noupgradepackages));
            //Toast.makeText(ac, a.getResources().getString(R.string.noupgradepackages), 6000).show();
            return new ko("KO 59588 apk not in disk");
        }
        File f = cfg_public.public_file("newapk_content");
        if (f == null) {
            ko r = new ko("KO 30029 newapk_content doesn't open.");
            return r;
        }
        try {
            Intent intent = new Intent(Intent.ACTION_VIEW);
            intent.setDataAndType(FileProvider.getUriForFile(a.getApplicationContext(), a.getApplicationContext().getPackageName()+".provider", f), "application/vnd.android.package-archive");
            intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_GRANT_READ_URI_PERMISSION);
            ac.startActivity(intent);
        }
        catch (Exception e) {
            error_manager.manage(e, "KO 60508");
        }
        return ok;
    }

    public void do_inst_ask_permission(activity ac) {
        if (CFG.appstore_edition == 1) {
            final String appPackageName = ac.getPackageName(); // getPackageName() from Context or Activity object
            try {
                ac.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("market://details?id=" + appPackageName)));
            } catch (android.content.ActivityNotFoundException anfe) {
                ac.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://play.google.com/store/apps/details?id=" + appPackageName)));
            }
            return;
        }
        int n = 5;
        while (true) {
            if (--n == 0) break;
            if (a.getPackageManager().canRequestPackageInstalls()) {
                ko r = do_inst_local(ac);
                if (r != KO_60599) { //retry in 
                    break;
                }
            }
            else {
                Intent i = new Intent(Settings.ACTION_MANAGE_UNKNOWN_APP_SOURCES).setData(Uri.parse(String.format("package:%s", a.getPackageName())));
                ac.startActivityForResult(i, activity.INSTALL_PACKAGES_REQUESTCODE);
                return;
            }

            try {
                Thread.sleep(5000);
            }
            catch(InterruptedException e) {
            }
            continue;                
        }
    }

    void check4updates() {
        toast("Checking for updates...");
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                check(true);
            }
        });
        thread.start();
    }
    void check4updates__worker() {
        new Exception().printStackTrace();
        //keep the calling thread (work dispatcher) fast
        Thread thread = new Thread(new Runnable() {
            @Override public void run() {
                check(true);
            }
        });
        thread.start();
    }

    public void show_ui(final activity ac) {
//        String[] options = {a.getResources().getString(R.string.checkforupdates), a.getResources().getString(R.string.forgetapknash) + " " + get_curapk(), a.getResources().getString(R.string.installupdates), a.getResources().getString(R.string.cancel)};
        String[] options;

//        boolean blob_available = need_install_local_apk()
/*
        if (is_updateavailable) {
            String[] opt = {a.getResources().getString(R.string.checkforupdates), a.getResources().getString(R.string.installupdates), a.getResources().getString(R.string.cancel)};
            options = opt;
        }
        else {
*/
        String[] opt = {a.getResources().getString(R.string.checkforupdates), a.getResources().getString(R.string.cancel)};
        options = opt;
//        }
        final sw_updates_t i = this;
        new AlertDialog.Builder(ac).setTitle(a.getResources().getString(R.string.appupdates))
            .setItems(options, new DialogInterface.OnClickListener() {
                @Override public void onClick(DialogInterface dialog, int which) {
                    switch(which) {
                        case 0:
                            i.check4updates();
                            break;
/*
                        case 1:
                            i.forget_curapk();
                            break;
                        case 1:
                            if (is_updateavailable) {
                                ko r = i.do_inst_ask_permission(ac);
                                if (is_ko(r)) {
                                    if (a.main != null) {
                                        a.main.toast(r.msg);
                                    }
                                }
                                break;
                            }
                        case 2:
*/  
                    }
                }
            })
            .setIcon(android.R.drawable.ic_dialog_alert).show();
    }

/*
    private void sw_updates_show_ui(activity ac) {
    }

    private void sw_updates_do_inst(activity ac) {
    }
    private boolean sw_updates_is_updateavailable = false;
*/

//    public boolean is_updateavailable = false;


    String curapk = "";
    app a;
    hmi_t hmi;
    cfg_android_private_t cfg_private;
    cfg_android_public_t cfg_public;
    Instant user_selected_remind_me_later = null;
}

