package plebble.trader;
import java.util.ArrayList;                                                                    // ArrayList
import android.content.Context;                                                                // Context
import us.wallet.trader.data_t;                                                                // data_t
import java.util.HashMap;                                                                      // HashMap
import static us.gov.crypto.ripemd160.hash_t;                                                  // hash_t
import static us.stdint.*;                                                                     // *
import static us.tuple.*;                                                                      // *
import us.ko;                                                                                  // ko
import java.util.Map;                                                                          // Map
import static us.ko.ok;                                                                        // ok
import us.pair;                                                                                // pair
import android.view.View;                                                                      // View

public class workflow_t extends HashMap<String, pair<workflow_item_t, workflow_item_t>> { //local, remote


    public workflow_t(data_t data) {
        for (Map.Entry<String, String> i: data.entrySet()) {
            if (i.getKey().startsWith("local__wf_")) {
                add(0, i.getKey().substring(10), i.getValue());
                continue;
            }
            if (i.getKey().startsWith("remote__wf_")) {
                add(1, i.getKey().substring(11), i.getValue());
                continue;
            }
        }
    }

    void add(int section, String prop, String value) {
        String[] docprop = prop.split("_", 2);
        pair<workflow_item_t, workflow_item_t> i = get(docprop[0]);
        if (i == null) {
            i = new pair<workflow_item_t, workflow_item_t>(new workflow_item_t(docprop[0]), new workflow_item_t(docprop[0]));
            put(docprop[0], i);
        }
        String wprop = null;
        if (docprop.length == 2) {
            wprop = docprop[1];
        }
        if (section == 0) {
            i.first.add(wprop, value);
        }
        else {
            i.second.add(wprop, value);
        }

    }

}

