#pragma once
#include <us/gov/config.h>

#if CFG_COUNTERS == 1

#include <us/gov/types.h>

namespace us::gov::cash {

    struct counters_t final {
        uint32_t tx_rejected_bad_amounts{0};
        uint32_t tx_rejected_state{0};
        uint32_t tx_rejected_could_not_unlock_input{0};
        uint32_t tx_rejected_locking_program_mismatch{0};
        uint32_t tx_processed{0};

        void dump(ostream&) const;
    };

}

#endif

