#pragma once
#include <us/gov/config.h>
#if CFG_COUNTERS == 1

#include <us/gov/types.h>

namespace us::gov::engine::auth {

    struct counters_t final {
        uint32_t basic_auth_completed{0};
        uint32_t not_authorized{0};
        uint32_t invalid_net_address{0};
        uint32_t sysop_connections{0};
        uint32_t node_connections{0};
        uint32_t out_connections{0};
        uint32_t hall_connections{0};

        void dump(ostream&) const;
    };

}

#endif

