#include <us/gov/engine/protocol.h>

#include "types.h"
#include "peer_t.h"

#define loglevel "gov/engine"
#define logclass "peer_t__sys"
#include "logs.inc"
#include <us/gov/socket/dto.inc>

using namespace us::gov::engine;
using c = us::gov::engine::peer_t;

#include <us/api/generated/gov/c++/sys/cllr_rpc-impl>

bool c::process_work__sys(datagram* d) {
    using namespace protocol;
    switch(d->service) {
        #include <us/api/generated/gov/c++/sys/hdlr_svc-router>
    }
    return false;
}

#include <us/api/generated/gov/c++/sys/hdlr_svc_handler-impl>

//------------------apitool - API Spec defined @ us/api/generated/gov/c++/sys/hdlr_local-impl

ko c::handle_f1() {
    log("f1");

    // Implement here.

    return ok;
}

//-/----------------apitool - End of API implementation.

