#include <us/gov/config.h>

#include "svcfish_t.h"

#define loglevel "gov/engine"
#define logclass "svcfish_t"
#include "logs.inc"

using namespace us::gov::engine;
using namespace us;

using c = us::gov::engine::svcfish_t;

svc_t c::from_prev(svc_t svc) const {
    auto i = db01.find(svc);
    if (i == db01.end()) {
        return svc;
    }
    return i->second;
}

us::svc_t c::to_prev(svc_t svc) const {
    auto i = db10.find(svc);
    if (i == db10.end()) {
        return svc;
    }
    return i->second;
}

