#pragma once
#include <us/gov/peer/peer_t.h>

#include "api.h"
#include "types.h"

namespace us::gov::relay {

    struct peer_t: base_ns::peer_t, api  {
        using b = base_ns::peer_t;
        using b::peer_t;

        bool process_work(datagram*) override;

        #ifdef has_us_gov_relay_api
            #include <us/api/generated/gov/c++/relay/hdlr_override>
            #include <us/api/generated/gov/c++/relay/hdlr_svc_handler-hdr>
            #include <us/api/generated/gov/c++/relay/cllr_override>
        #endif
    };

}

