package us.gov.engine;
import us.CFG;                                                                                 // CFG
import static us.gov.socket.types.channel_t;                                                   // channel_t
import us.gov.socket.client;                                                                   // client
import static us.gov.socket.datagram.dispatcher_t;                                             // dispatcher_t
import us.gov.crypto.ec;                                                                       // ec
import java.io.PrintStream;                                                                    // PrintStream

public abstract class rpc_daemon_t extends us.gov.dfs.rpc_daemon_t {


    public rpc_daemon_t(channel_t channel, dispatcher_t dispatcher) {
        super(channel, dispatcher);
        api_v.value = us.CFG.API_V__GOV.value;
        assert api_v.value != 0;
    }

/*
    @Override public client create_client() {
        return new rpc_peer_t(this);
    }
*/

    @Override public void dump(final String prefix, PrintStream os) {
        os.println(prefix + "engine::rpc_daemon_t:");
        super.dump(prefix, os);
    }

    public static svcfish_t svcfish = new svcfish_t();
}

