#include <iostream>
#include <fstream>

#include <us/gov/config.h>
#include <us/gov/engine/calendar.h>

#include "test_platform.h"

#define loglevel "test"
#define logclass "calendar"
#include "logs.inc"

#include "assert.inc"

namespace us { namespace test {

using namespace std;
using namespace chrono;
using namespace chrono_literals;


struct calendar: us::gov::engine::calendar_t, us::test::test_platform {
    typedef us::test::test_platform t;

    calendar(ostream&os):t(os) {
    }

    void self_test() {
        os << "from " << last_processed << " to " << block_closure << endl;
        uint64_t expected=duration_cast<nanoseconds>(cycle_period).count()+1;
        check(block_closure-last_processed, expected);

        check(has(0), false);

    }

};

int main_calendar() {

    calendar c(cout);
    c.self_test();
    return 0;
}

}}

