#pragma once

#include "node.h"

namespace us::test {

    using namespace std;

    struct node_bank: node {
        using b = node;

        node_bank(const string& id, const string& homedir, const string& logdir, const string& vardir, uint16_t gport, uint16_t wport);
        void update_plugins(const string& destdir) override;
        bool load_data(const string& r2rhome) override;
        string desc() const override;
        vector<string> r2r_libs(bool filter_not_active) override;
        void create_bank(const string& r2rhome);
        void banner(ostream& os) const override;

    };

}

