#include "svcfish_t.h"

#include <us/gov/config.h>

#define loglevel "wallet/engine"
#define logclass "svcfish_t"
#include <us/gov/logs.inc>

using namespace us::wallet::engine;
using namespace us;

using c = us::wallet::engine::svcfish_t;

svc_t c::from_prev(svc_t svc) const {
    auto i = db01.find(svc);
    if (i == db01.end()) {
        return svc;
    }
    return i->second;
}

us::svc_t c::to_prev(svc_t svc) const {
    auto i = db10.find(svc);
    if (i == db10.end()) {
        return svc;
    }
    return i->second;
}

