#pragma once
#include <us/gov/relay/rpc_peer_t.h>
#include <us/gov/config.h>

#include "rpc_daemon_t.h"
#include "api.h"
#include "types.h"

namespace us::gov::dfs {

    struct rpc_peer_t: base_ns::rpc_peer_t, caller_api {
        using b = base_ns::rpc_peer_t;

        rpc_peer_t(rpc_daemon_t&);

        #ifdef has_us_gov_dfs_api
            #include <us/api/generated/gov/c++/dfs/cllr_override>
        #endif
    };

}

