#pragma once
#include <unordered_map>
#include <mutex>

#include <us/gov/config.h>
#include "types.h"

namespace us::gov::engine {

    struct diff;
    struct local_deltas_t;

    struct pools_t final: unordered_map<ts_t, diff*> {

        ~pools_t();

        bool add(local_deltas_t*, bool create_diff);
        diff* close(ts_t id);

        mutable mutex mx;
    };

}

