#pragma once
#include <unordered_map>
#include <mutex>

#include <us/gov/types.h>
#include <us/gov/config.h>

#include "shell.h"

namespace us::gov::engine {

    struct daemon_t;
    struct peer_t;

    struct sysops_t final: unordered_map<peer_t*, shell> {
        sysops_t(daemon_t& d): d(d) {}
        ko exec(peer_t*, const string& cmd, ostream&);

    public:
        mutex mx;
        daemon_t& d;
    };

}

