#pragma once
#include <us/gov/config.h>
#include <us/gov/auth/peer_t.h>
#include "api.h"
#include "types.h"

namespace us::gov::peer {

    struct rpc_peer_t: base_ns::peer_t, caller_api {
        using b = base_ns::peer_t;

        using b::peer_t;

        void dump_all(const string& prefix, ostream&) const override;
        void dump(const string& prefix, ostream&) const;

    public:
        #ifdef has_us_gov_peer_api
            #include <us/api/generated/gov/c++/peer/cllr_override>
        #endif

    };

}

