#pragma once
#include <string>

#ifdef DEBUG
   #include <type_traits>
   struct assert_is_root_namespace;
   static_assert(std::is_same<assert_is_root_namespace, ::assert_is_root_namespace>::value, "Not root namespace. Check includes.");
#endif

namespace us {

    using namespace std;

    using shost_t = string;
    using host_t = uint32_t;
    using port_t = uint16_t;
    using shostport_t = pair<shost_t, port_t>;
    using hostport_t = pair<host_t, port_t>;
    using channel_t = uint16_t;
    using svc_t = uint16_t;
    using seq_t = uint16_t;
    using reason_t = string;
    using ts_t = uint64_t; //nanosec
    using ts_ms_t = uint64_t; //millisec
    using sock_t = int;
    using api_v_t = uint8_t;
}

namespace us::gov::socket {

    using namespace us;

}

